/*
*********************************************************************************************************
*
*	ģ : TFTҺʾģ
*	ļ : LCD_tft_lcd.h
*	     : V2.0
*	˵     : ͷļ
*
*	Copyright (C), 2010-2011,  www.armfly.com
*
*********************************************************************************************************
*/


#ifndef _BSP_TFT_LCD_H
#define _BSP_TFT_LCD_H

/* LCDʾķֱ */
#define LCD_30_HEIGHT	240		/* 3.0 ߶ȣλ */
#define LCD_30_WIDTH	400		/* 3.0 ȣλ */

#define LCD_43_HEIGHT	272		/* 4.3 ߶ȣλ */
#define LCD_43_WIDTH	480		/* 4.3 ȣλ */

#define LCD_70_HEIGHT	480		/* 7.0 ߶ȣλ */
#define LCD_70_WIDTH	800		/* 7.0 ȣλ */

/* ֵ֧оƬID */
enum
{
	IC_5420		= 0x5420,
	IC_4001		= 0x4001,
	IC_61509 	= 0xB509,
	IC_8875 	= 0x0075
};

#define CHIP_STR_5420	"SPFD5420A"
#define CHIP_STR_4001	"OTM4001A"
#define CHIP_STR_61509	"R61509V"
#define CHIP_STR_8875	"RA8875"

/*
	LCD ɫ룬CL_Colorļд
	16Bitɸλλ RRRR RGGG GGGB BBBB

	RGB 꽫24λRGBֵתΪ16λʽ
	windowsĻʳ򣬵༭ɫѡԶɫԻõRGBֵ

	Ƽʹȡɫ㿴Ľɫ
*/
#define RGB(R,G,B)	(((R >> 3) << 11) | ((G >> 2) << 5) | (B >> 3))	/* 8λR,G,BתΪ 16λRGB565ʽ */
#define RGB565_R(x)  ((x >> 8) & 0xF8)
#define RGB565_G(x)  ((x >> 3) & 0xFC)
#define RGB565_B(x)  ((x << 3) & 0xF8)
enum
{
	CL_WHITE        = RGB(255,255,255),	/* ɫ */
	CL_BLACK        = RGB(  0,  0,  0),	/* ɫ */
	CL_RED          = RGB(255,	0,  0),	/* ɫ */
	CL_GREEN        = RGB(  0,255,  0),	/* ɫ */
	CL_BLUE         = RGB(  0,	0,255),	/* ɫ */
	CL_YELLOW       = RGB(255,255,  0),	/* ɫ */

	CL_GREY			= RGB( 98, 98, 98), 	/* ɫ */
	CL_GREY1		= RGB( 150, 150, 150), 	/* ǳɫ */
	CL_GREY2		= RGB( 180, 180, 180), 	/* ǳɫ */
	CL_GREY3		= RGB( 200, 200, 200), 	/* ǳɫ */
	CL_GREY4		= RGB( 230, 230, 230), 	/* ǳɫ */

	CL_BUTTON_GREY	= RGB( 220, 220, 220), /* WINDOWS ťɫ */

	CL_MAGENTA      = 0xF81F,	/* ɫɫ */
	CL_CYAN         = 0x7FFF,	/* ɫɫ */

	CL_BLUE1        = RGB(  0,  0, 240),		/* ɫ */
	CL_BLUE2        = RGB(  0,  0, 128),		/* ɫ */
	CL_BLUE3        = RGB(  68, 68, 255),		/* ǳɫ1 */
	CL_BLUE4        = RGB(  0, 64, 128),		/* ǳɫ1 */

	/* UI  Windowsؼɫ */
	CL_BTN_FACE		= RGB(236, 233, 216),	/* ťɫ() */
	CL_BOX_BORDER1	= RGB(172, 168,153),	/* ɫ */
	CL_BOX_BORDER2	= RGB(255, 255,255),	/* Ӱɫ */


	CL_MASK			= 0x9999	/* ɫ룬ֱ͸ */
};

/* ༭ */
enum
{
	EDIT_BORDER_COLOR		= CL_BLUE2,		/* ༭ĸߵɫ */
	EDIT_BACK_COLOR			= CL_WHITE,			/* ༭򱳾 */
};

/* ť */
enum
{
	BUTTON_BORDER_COLOR		= CL_BLUE2,			/* ťĸߵɫ */
	BUTTON_BORDER1_COLOR	= CL_WHITE,			/* ťĸڲ2еɫ */
	BUTTON_BORDER2_COLOR	= CL_GREY1,			/* ťĸڲ2еɫ */
	BUTTON_BACK_COLOR		= CL_GREY3,			/* ť */
	BUTTON_ACTIVE_COLOR		= CL_CYAN,			/* İť */
};

/* ڷ */
enum
{
	WIN_BORDER_COLOR	= CL_BLUE4,		/* ڱ߿ */
	WIN_TITLE_COLOR		= CL_BLUE3,		/* ڱɫ */
	WIN_CAPTION_COLOR	= CL_WHITE,		/* ڱɫ */
	WIN_BODY_COLOR		= CL_GREY2,		/* ɫ */
};

/*  */
enum
{
	CHECK_BOX_BORDER_COLOR	= CL_BLUE2,		/* ĸߵɫ */
	CHECK_BOX_BACK_COLOR	= CL_GREY3,		/* 򱳾 */
	CHECK_BOX_CHECKED_COLOR	= CL_RED,		/* 򹴵ɫ */

	CHECK_BOX_H			= 24,				/* ߶ */
	CHECK_BOX_W			= 24,				/* ߶ */
};

/*  */
typedef enum
{
	FC_ST_16 = 0,		/* 15x16 xߣ */
	FC_ST_12 = 1		/* 12x12 xߣ */
}FONT_CODE_E;

/* Խṹ, LCD_DispStr() */
typedef struct
{
	uint16_t FontCode;	/*  0 ʾ16 */
	uint16_t FrontColor;	/* ɫ */
	uint16_t BackColor;	/* ֱɫ͸ */
	uint16_t Space;		/* ּ࣬λ =  */
}FONT_T;

/* ؼID */
typedef enum
{
	ID_ICON		= 1,
	ID_WIN		= 2,
	ID_LABEL	= 3,
	ID_BUTTON	= 4,
	ID_CHECK 	= 5,
	ID_EDIT 	= 6,
	ID_GROUP 	= 7,
}CONTROL_ID_T;

/* ͼṹ */
typedef struct
{
	uint8_t id;
	uint16_t Left;		/* ϽX */
	uint16_t Top;		/* ϽY */
	uint16_t Height;	/* ͼ߶ */
	uint16_t Width;		/* ͼ */
	uint16_t *pBmp;		/* ָͼͼƬ */
	char  Text[16];	/* ͼı, ʾ516 */
}ICON_T;

/* ṹ */
typedef struct
{
	uint8_t id;
	uint16_t Left;
	uint16_t Top;
	uint16_t Height;
	uint16_t Width;
	uint16_t Color;
	FONT_T *Font;
	char *pCaption;
}WIN_T;

/* ıǩṹ */
typedef struct
{
	uint8_t id;
	uint16_t Left;			/* ϽX */
	uint16_t Top;			/* ϽY */
	uint16_t Height;		/* ߶ */
	uint16_t Width;			/*  */
	uint16_t MaxLen;		/* ַ */
	FONT_T *Font;			/*  */
	char  *pCaption;
}LABEL_T;

/* ťṹ */
typedef struct
{
	uint8_t id;
	uint16_t Left;
	uint16_t Top;
	uint16_t Height;
	uint16_t Width;
	/* ťɫɵײԶ */
	FONT_T *Font;			/*  */
	char *pCaption;
	uint8_t Focus;			/*  */
}BUTTON_T;

/* ༭ṹ */
typedef struct
{
	uint8_t id;
	uint16_t Left;
	uint16_t Top;
	uint16_t Height;
	uint16_t Width;
	uint16_t Color;
	FONT_T *Font;			/*  */
	char   *pCaption;
	char Text[32];			/* ڴű༭ */
}EDIT_T;

/*  CHECK BOX ṹ */
typedef struct
{
	uint8_t id;
	uint16_t Left;			/* ϽX */
	uint16_t Top;			/* ϽY */
	uint16_t Height;		/* ߶ */
	uint16_t Width;			/*  */
	uint16_t Color;			/* ɫ */
	FONT_T *Font;			/*  */
	char  *pCaption;
	uint8_t Checked;		/* 1ʾ */
}CHECK_T;

/* GROUP BOX ṹ */
typedef struct
{
	uint8_t id;
	uint16_t Left;			/* ϽX */
	uint16_t Top;			/* ϽY */
	uint16_t Height;		/* ߶ */
	uint16_t Width;			/*  */
	FONT_T *Font;			/*  */
	char  *pCaption;
}GROUP_T;

/*  */
#define BRIGHT_MAX		255
#define BRIGHT_MIN		0
#define BRIGHT_DEFAULT	200
#define BRIGHT_STEP		5

/* ɹⲿģõĺ */
void LCD_InitHard(void);
void LCD_GetChipDescribe(char *_str);
uint16_t LCD_GetHeight(void);
uint16_t LCD_GetWidth(void);
void LCD_DispOn(void);
void LCD_DispOff(void);
void LCD_ClrScr(uint16_t _usColor);
void LCD_DispStr(uint16_t _usX, uint16_t _usY, char *_ptr, FONT_T *_tFont);
void LCD_PutPixel(uint16_t _usX, uint16_t _usY, uint16_t _usColor);
uint16_t LCD_GetPixel(uint16_t _usX, uint16_t _usY);
void LCD_DrawLine(uint16_t _usX1 , uint16_t _usY1 , uint16_t _usX2 , uint16_t _usY2 , uint16_t _usColor);
void LCD_DrawPoints(uint16_t *x, uint16_t *y, uint16_t _usSize, uint16_t _usColor);
void LCD_DrawRect(uint16_t _usX, uint16_t _usY, uint16_t _usHeight, uint16_t _usWidth, uint16_t _usColor);
void LCD_DrawCircle(uint16_t _usX, uint16_t _usY, uint16_t _usRadius, uint16_t _usColor);
void LCD_DrawBMP(uint16_t _usX, uint16_t _usY, uint16_t _usHeight, uint16_t _usWidth, uint16_t *_ptr);
void LCD_SetBackLight(uint8_t _bright);
uint8_t LCD_GetBackLight(void);

void LCD_Fill_Rect(uint16_t _usX, uint16_t _usY, uint16_t _usHeight, uint16_t _usWidth, uint16_t _usColor);

void LCD_DrawWin(WIN_T *_pWin);
void LCD_DrawIcon(const ICON_T *_tIcon, FONT_T *_tFont, uint8_t _ucFocusMode);
void LCD_DrawEdit(EDIT_T *_pEdit);
void LCD_DrawButton(BUTTON_T *_pBtn);
void LCD_DrawLabel(LABEL_T *_pLabel);
void LCD_DrawCheckBox(CHECK_T *_pCheckBox);
void LCD_DrawGroupBox(GROUP_T *_pBox);

void LCD_DispControl(void *_pControl);

void LCD_DrawIcon32(const ICON_T *_tIcon, FONT_T *_tFont, uint8_t _ucFocusMode);
void LCD_DrawBmp32(uint16_t _usX, uint16_t _usY, uint16_t _usHeight, uint16_t _usWidth, uint8_t *_pBmp);

/* 3Ҫʹͬʱֲ֧ͬ */
extern uint16_t g_ChipID;			/* оƬID */
extern uint16_t g_LcdHeight;		/* ʾֱ-߶ */
extern uint16_t g_LcdWidth;			/* ʾֱ- */

#endif


