/*
*********************************************************************************************************
*
*	ģ : ж+FIFOģ
*	ļ : bsp_uart_fifo.h
*	     : V1.0
*	˵     : ͷļ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

#ifndef _BSP_USART_FIFO_H_
#define _BSP_USART_FIFO_H_

/*
	ҪĴڶӦĹܽţ޸ bsp_uart_fifo.cļе static void InitHardUart(void)
*/

/* ʹܵĴ, 0 ʾʹܣӴС 1ʾʹ */
#ifdef STM32_X3	/*  STM32-X4  */
	/* STM32-X3崮ڷ䣺
		PA9/USART1_TX	  --- ӡԿ
		PA10/USART1_RX
	*/
	#define	UART1_FIFO_EN	1
	#define	UART2_FIFO_EN	0
	#define	UART3_FIFO_EN	0
	#define	UART4_FIFO_EN	0
	#define	UART5_FIFO_EN	0
	#define	UART6_FIFO_EN	0
#else
	/*
		STM32-V5 ڷ䣺
		1 RS232 оƬ1·
			PB6/USART1_TX	  --- ӡԿ
			PB7/USART1_RX

		2 PA2 ̫ܽ RXܽڽGPSź
			PA2/USART2_TX/ETH_MDIO (̫ڷ)
			PA3/USART2_RX	;GPSģ

		3 RS485 ͨ - TTL   
			PB10/USART3_TX
			PB11/USART3_RX

		4 --- á
		5 --- á

		6--- GPRSģ Ӳأ
			PC6/USART6_TX
			PC7/USART6_RX
			PG8/USART6_RTS
			PG15/USART6_CTS
	*/
	#define	UART1_FIFO_EN	1
	#define	UART2_FIFO_EN	1
	#define	UART3_FIFO_EN	1
	#define	UART4_FIFO_EN	0
	#define	UART5_FIFO_EN	0
	#define	UART6_FIFO_EN	1

	/* RS485оƬʹGPIO, PB2 */
	#define RCC_RS485_TXEN 	RCC_AHB1Periph_GPIOB
	#define PORT_RS485_TXEN  GPIOB
	#define PIN_RS485_TXEN	 GPIO_Pin_2

	#define RS485_RX_EN()	PORT_RS485_TXEN->BSRRH = PIN_RS485_TXEN
	#define RS485_TX_EN()	PORT_RS485_TXEN->BSRRL = PIN_RS485_TXEN
#endif

/* ˿ں */
typedef enum
{
	COM1 = 0,	/* USART1  PA9, PA10   PB6, PB7*/
	COM2 = 1,	/* USART2, PD5,PD6  PA2, PA3 */
	COM3 = 2,	/* USART3, PB10, PB11 */
	COM4 = 3,	/* UART4, PC10, PC11 */
	COM5 = 4,	/* UART5, PC12, PD2 */
	COM6 = 5	/* USART6, PC6, PC7 */
}COM_PORT_E;

/* 崮ڲʺFIFOСΪͻͽջ, ֧ȫ˫ */
#if UART1_FIFO_EN == 1
	#define UART1_BAUD			115200
	#define UART1_TX_BUF_SIZE	1*1024
	#define UART1_RX_BUF_SIZE	1*1024
#endif

#if UART2_FIFO_EN == 1
	#define UART2_BAUD			9600
	#define UART2_TX_BUF_SIZE	1
	#define UART2_RX_BUF_SIZE	2*1024
#endif

#if UART3_FIFO_EN == 1
	#define UART3_BAUD			9600
	#define UART3_TX_BUF_SIZE	1*1024
	#define UART3_RX_BUF_SIZE	1*1024
#endif

#if UART4_FIFO_EN == 1
	#define UART4_BAUD			115200
	#define UART4_TX_BUF_SIZE	1*1024
	#define UART4_RX_BUF_SIZE	1*1024
#endif

#if UART5_FIFO_EN == 1
	#define UART5_BAUD			115200
	#define UART5_TX_BUF_SIZE	1*1024
	#define UART5_RX_BUF_SIZE	1*1024
#endif

#if UART6_FIFO_EN == 1
	#define UART6_BAUD			115200
	#define UART6_TX_BUF_SIZE	1*1024
	#define UART6_RX_BUF_SIZE	1*1024
#endif

/* 豸ṹ */
typedef struct
{
	USART_TypeDef *uart;		/* STM32ڲ豸ָ */
	uint8_t *pTxBuf;			/* ͻ */
	uint8_t *pRxBuf;			/* ջ */
	uint16_t usTxBufSize;		/* ͻС */
	uint16_t usRxBufSize;		/* ջС */
	uint16_t usTxWrite;			/* ͻдָ */
	uint16_t usTxRead;			/* ͻָ */
	uint16_t usTxCount;			/* ȴ͵ݸ */

	uint16_t usRxWrite;			/* ջдָ */
	uint16_t usRxRead;			/* ջָ */
	uint16_t usRxCount;			/* δȡݸ */

	void (*SendBefor)(void); 	/* ʼ֮ǰĻصָ루ҪRS485лģʽ */
	void (*SendOver)(void); 	/* ϵĻصָ루ҪRS485ģʽлΪģʽ */
	void (*ReciveNew)(void);	/* յݵĻصָ */
}UART_T;

void bsp_InitUart(void);
void comSendBuf(COM_PORT_E _ucPort, uint8_t *_ucaBuf, uint16_t _usLen);
void comSendChar(COM_PORT_E _ucPort, uint8_t _ucByte);
uint8_t comGetChar(COM_PORT_E _ucPort, uint8_t *_pByte);

void comClearTxFifo(COM_PORT_E _ucPort);
void comClearRxFifo(COM_PORT_E _ucPort);

#endif

/*****************************  www.armfly.com (END OF FILE) *********************************/
