/*
*********************************************************************************************************
*
*	ģ : AD7606ݲɼģ
*	ļ : bsp_ad7606.c
*	     : V1.0
*	˵     : AD7606STM32FSMCϡ
*
*			ʹ TIM4 ΪӲʱʱADCת
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-02-01 armfly  ʽ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"


/* ùGPIO: PH9 PH10 PH11 */
#define OS0_1()		GPIOH->BSRRL = GPIO_Pin_9
#define OS0_0()		GPIOH->BSRRH = GPIO_Pin_9
#define OS1_1()		GPIOH->BSRRL = GPIO_Pin_10
#define OS1_0()		GPIOH->BSRRH = GPIO_Pin_10
#define OS2_1()		GPIOH->BSRRL = GPIO_Pin_11
#define OS2_0()		GPIOH->BSRRH = GPIO_Pin_11

/* ADתGPIO : PH12  , PH12/TIM5_CH3/DCMI_D3 */
#define CONVST_1()	GPIOH->BSRRL = GPIO_Pin_12
#define CONVST_0()	GPIOH->BSRRH = GPIO_Pin_12

/* ̵GPIO :  */
#define RANGE_1()	GPIOH->BSRRL = GPIO_Pin_14
#define RANGE_0()	GPIOH->BSRRH = GPIO_Pin_14

/* AD7606λ : PI4  */
#define RESET_1()	GPIOI->BSRRL = GPIO_Pin_4
#define RESET_0()	GPIOI->BSRRH = GPIO_Pin_4

/* AD7606 FSMCߵַֻܶд */
#define AD7606_RESULT()	*(__IO uint16_t *)0x6C400000

AD7606_VAR_T g_tAD7606;		/* 1ȫֱһЩ */
AD7606_FIFO_T g_tAdcFifo;	/* FIFOṹ */

static void AD7606_CtrlLinesConfig(void);
static void AD7606_FSMCConfig(void);

/*
*********************************************************************************************************
*	  : bsp_InitAD7606
*	˵: ⲿSRAMGPIOFSMC
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitAD7606(void)
{
	AD7606_CtrlLinesConfig();
	AD7606_FSMCConfig();

	AD7606_SetOS(AD_OS_NO);		/* ޹ */
	AD7606_SetInputRange(0);	/* 0ʾΪ5V, 1ʾ10V */

	AD7606_Reset();

	CONVST_1();					/* תGPIOƽʱΪ */
}

/*
*********************************************************************************************************
*	  : AD7606_CtrlLinesConfig
*	˵: LCDƿߣFSMCܽΪù
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
/*
	STM32-V5߷

	PD0/FSMC_D2
	PD1/FSMC_D3
	PD4/FSMC_NOE		--- źţOE = Output Enable  N ʾЧ
	PD5/FSMC_NWE		--- дźţAD7606 ֻждź
	PD8/FSMC_D13
	PD9/FSMC_D14
	PD10/FSMC_D15

	PD14/FSMC_D0
	PD15/FSMC_D1

	PE4/FSMC_A20		--- Ƭѡһ
	PE5/FSMC_A21		--- Ƭѡһ
	PE7/FSMC_D4
	PE8/FSMC_D5
	PE9/FSMC_D6
	PE10/FSMC_D7
	PE11/FSMC_D8
	PE12/FSMC_D9
	PE13/FSMC_D10
	PE14/FSMC_D11
	PE15/FSMC_D12

	PG12/FSMC_NE4		--- ƬѡTFT, OLED  AD7606

	ĿIO:

	PH9/DCMI_D0/AD7606_OS0			---> AD7606_OS0		OS2:OS0 ѡ˲
	PH10/DCMI_D1/AD7606_OS1         ---> AD7606_OS1
	PH11/DCMI_D2/AD7606_OS2         ---> AD7606_OS2
	PH12/DCMI_D3/AD7606_CONVST      ---> AD7606_CONVST	ADCת (CONVSTA  CONVSTB Ѿ)
	PH14/DCMI_D4/AD7606_RAGE        ---> AD7606_RAGE	ģѹ̣5V10V
	PI4/DCMI_D5/AD7606_RESET        ---> AD7606_RESET	λ
	PI6/DCMI_D6/AD7606_BUSY         ---> AD7606_BUSY	æź	(δʹ)

*/
static void AD7606_CtrlLinesConfig(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	/* ʹFSMCʱ */
	RCC_AHB3PeriphClockCmd(RCC_AHB3Periph_FSMC, ENABLE);

	/* ʹ GPIOʱ */
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD | RCC_AHB1Periph_GPIOE | RCC_AHB1Periph_GPIOG, ENABLE);

	/*  PD.00(D2), PD.01(D3), PD.04(NOE), PD.05(NWE), PD.08(D13), PD.09(D14),
	 PD.10(D15), PD.14(D0), PD.15(D1) Ϊ */

	GPIO_PinAFConfig(GPIOD, GPIO_PinSource0, GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOD, GPIO_PinSource1, GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOD, GPIO_PinSource4, GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOD, GPIO_PinSource5, GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOD, GPIO_PinSource8, GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOD, GPIO_PinSource9, GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOD, GPIO_PinSource10, GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOD, GPIO_PinSource14, GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOD, GPIO_PinSource15, GPIO_AF_FSMC);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_4 | GPIO_Pin_5 |
	                            GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_14 |
	                            GPIO_Pin_15;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOD, &GPIO_InitStructure);

	/*
		PE4/FSMC_A20		--- Ƭѡһ
		PE5/FSMC_A21		--- Ƭѡһ

		PE.07(D4), PE.08(D5), PE.09(D6), PE.10(D7), PE.11(D8), PE.12(D9), PE.13(D10),
	 	PE.14(D11), PE.15(D12)
	*/
	GPIO_PinAFConfig(GPIOE, GPIO_PinSource4 , GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOE, GPIO_PinSource5 , GPIO_AF_FSMC);

	GPIO_PinAFConfig(GPIOE, GPIO_PinSource7 , GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOE, GPIO_PinSource8 , GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOE, GPIO_PinSource9 , GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOE, GPIO_PinSource10 , GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOE, GPIO_PinSource11 , GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOE, GPIO_PinSource12 , GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOE, GPIO_PinSource13 , GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOE, GPIO_PinSource14 , GPIO_AF_FSMC);
	GPIO_PinAFConfig(GPIOE, GPIO_PinSource15 , GPIO_AF_FSMC);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_7 | GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 |
	                            GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 |
	                            GPIO_Pin_15;
	GPIO_Init(GPIOE, &GPIO_InitStructure);

	/*  PG12  Ϊ */
	GPIO_PinAFConfig(GPIOG, GPIO_PinSource12, GPIO_AF_FSMC);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
	GPIO_Init(GPIOG, &GPIO_InitStructure);

	/*	üõGPIO
		PH9/DCMI_D0/AD7606_OS0			---> AD7606_OS0		OS2:OS0 ѡ˲
		PH10/DCMI_D1/AD7606_OS1         ---> AD7606_OS1
		PH11/DCMI_D2/AD7606_OS2         ---> AD7606_OS2
		PH12/DCMI_D3/AD7606_CONVST      ---> AD7606_CONVST	ADCת
		PH14/DCMI_D4/AD7606_RAGE        ---> AD7606_RAGE	ģѹ̣5V10V
		PI4/DCMI_D5/AD7606_RESET        ---> AD7606_RESET	λ

		PI6/DCMI_D6/AD7606_BUSY			---> AD7606_BUSY    תź
	*/
	{
		/* ʹ GPIOʱ */
		RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOH | RCC_AHB1Periph_GPIOI, ENABLE);

		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
		GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL;

		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_14;
		GPIO_Init(GPIOH, &GPIO_InitStructure);

		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
		GPIO_Init(GPIOI, &GPIO_InitStructure);
	}
}

/*
*********************************************************************************************************
*	  : AD7606_FSMCConfig
*	˵: FSMCڷʱ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void AD7606_FSMCConfig(void)
{
	FSMC_NORSRAMInitTypeDef  init;
	FSMC_NORSRAMTimingInitTypeDef  timing;

	/*
		AD7606Ҫ(3.3Vʱ)RDźŵ͵ƽ21nsߵƽ̿15ns

		 Ϊ˺ͬBANKLCDͬѡ3-0-6-1-0-0
		3-0-5-1-0-0  : RD߳75ns ͵ƽ50ns.  1usڿɶȡ8·ݵڴ档
		1-0-1-1-0-0  : RD75ns͵ƽִ12nsң½زҲ12ns.  ݶȡȷ
	*/
	/* FSMC_Bank1_NORSRAM4 configuration */
	timing.FSMC_AddressSetupTime = 3;
	timing.FSMC_AddressHoldTime = 0;
	timing.FSMC_DataSetupTime = 6;
	timing.FSMC_BusTurnAroundDuration = 1;
	timing.FSMC_CLKDivision = 0;
	timing.FSMC_DataLatency = 0;
	timing.FSMC_AccessMode = FSMC_AccessMode_A;

	/*
	 LCD configured as follow:
	    - Data/Address MUX = Disable
	    - Memory Type = SRAM
	    - Data Width = 16bit
	    - Write Operation = Enable
	    - Extended Mode = Enable
	    - Asynchronous Wait = Disable
	*/
	init.FSMC_Bank = FSMC_Bank1_NORSRAM4;
	init.FSMC_DataAddressMux = FSMC_DataAddressMux_Disable;
	init.FSMC_MemoryType = FSMC_MemoryType_SRAM;
	init.FSMC_MemoryDataWidth = FSMC_MemoryDataWidth_16b;
	init.FSMC_BurstAccessMode = FSMC_BurstAccessMode_Disable;
	init.FSMC_AsynchronousWait = FSMC_AsynchronousWait_Disable;
	init.FSMC_WaitSignalPolarity = FSMC_WaitSignalPolarity_Low;
	init.FSMC_WrapMode = FSMC_WrapMode_Disable;
	init.FSMC_WaitSignalActive = FSMC_WaitSignalActive_BeforeWaitState;
	init.FSMC_WriteOperation = FSMC_WriteOperation_Enable;
	init.FSMC_WaitSignal = FSMC_WaitSignal_Disable;
	init.FSMC_ExtendedMode = FSMC_ExtendedMode_Disable;
	init.FSMC_WriteBurst = FSMC_WriteBurst_Disable;

	init.FSMC_ReadWriteTimingStruct = &timing;
	init.FSMC_WriteTimingStruct = &timing;

	FSMC_NORSRAMInit(&init);

	/* - BANK 1 (of NOR/SRAM Bank 1~4) is enabled */
	FSMC_NORSRAMCmd(FSMC_Bank1_NORSRAM4, ENABLE);
}

/*
*********************************************************************************************************
*	  : AD7606_SetOS
*	˵: AD7606˲Ҳùʡ
*			 ͨ AD7606_OS0OS1OS2ߵĵƽ״̬ʡ
*			 ADת֮AD7606ڲԶʵʣĲɼȻƽֵ
*
*			 ԽߣתʱԽ
*			 ޹ʱADתʱ 4us;
*				2ʱ = 8.7us;
*				4ʱ = 16us
*			 	64ʱ = 286us
*
*	    : _ucOS : , 0 - 6
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_SetOS(uint8_t _ucOS)
{
	g_tAD7606.ucOS = _ucOS;
	switch (_ucOS)
	{
		case AD_OS_X2:
			OS2_0();
			OS1_0();
			OS0_1();
			break;

		case AD_OS_X4:
			OS2_0();
			OS1_1();
			OS0_0();
			break;

		case AD_OS_X8:
			OS2_0();
			OS1_1();
			OS0_1();
			break;

		case AD_OS_X16:
			OS2_1();
			OS1_0();
			OS0_0();
			break;

		case AD_OS_X32:
			OS2_1();
			OS1_0();
			OS0_1();
			break;

		case AD_OS_X64:
			OS2_1();
			OS1_1();
			OS0_0();
			break;

		case AD_OS_NO:
		default:
			g_tAD7606.ucOS = AD_OS_NO;
			OS2_0();
			OS1_0();
			OS0_0();
			break;
	}
}

/*
*********************************************************************************************************
*	  : AD7606_SetInputRange
*	˵: AD7606ģź̡
*	    : _ucRange : 0 ʾ5V   1ʾ10V
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_SetInputRange(uint8_t _ucRange)
{
	if (_ucRange == 0)
	{
		g_tAD7606.ucRange = 0;
		RANGE_0();	/* Ϊ5V */
	}
	else
	{
		g_tAD7606.ucRange = 1;
		RANGE_1();	/* Ϊ10V */
	}
}

/*
*********************************************************************************************************
*	  : AD7606_Reset
*	˵: ӲλAD7606λָ֮״̬
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_Reset(void)
{
	RESET_0();	/* ˳λ״̬ */

	RESET_1();	/* 븴λ״̬ */
	RESET_1();	/* ӳ١ RESETλߵƽС50ns */
	RESET_1();
	RESET_1();

	RESET_0();	/* ˳λ״̬ */
}

/*
*********************************************************************************************************
*	  : AD7606_StartConvst
*	˵: 1ADCת
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_StartConvst(void)
{
	/* page 7  CONVST ߵƽȺ͵͵ƽ 25ns */
	/* CONVSTƽʱΪ */
	CONVST_0();
	CONVST_0();
	CONVST_0();

	CONVST_1();
}

/*
*********************************************************************************************************
*	  : AD7606_ReadNowAdc
*	˵: ȡ8·洢ȫֱ g_tAD7606
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_ReadNowAdc(void)
{
	g_tAD7606.sNowAdc[0] = AD7606_RESULT();	/* 1· */
	g_tAD7606.sNowAdc[1] = AD7606_RESULT();	/* 2· */
	g_tAD7606.sNowAdc[2] = AD7606_RESULT();	/* 3· */
	g_tAD7606.sNowAdc[3] = AD7606_RESULT();	/* 4· */
	g_tAD7606.sNowAdc[4] = AD7606_RESULT();	/* 5· */
	g_tAD7606.sNowAdc[5] = AD7606_RESULT();	/* 6· */
	g_tAD7606.sNowAdc[6] = AD7606_RESULT();	/* 7· */
	g_tAD7606.sNowAdc[7] = AD7606_RESULT();	/* 8· */
}

/*
*********************************************************************************************************
*		ĺڶʱɼģʽ TIM5ӲʱжжȡADCȫFIFO
*
*
*********************************************************************************************************
*/

/*
		CONVST ţPH12ʹTIM5_CH3PWM壬AD7606ADCת
		BUSYΪ½жϡжϷ򱣴ADC
*/

/*
*********************************************************************************************************
*	  : AD7606_EnterAutoMode
*	˵: ӲԶɼģʽ洢FIFO
*	    :  _ulFreq : ƵʣλHz	1k2k5k10k20K50k100k200k
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_EnterAutoMode(uint32_t _ulFreq)
{
	/* PH2ΪùܣTIM5_CH3 . ִкbsp_InitAD7606()PH2ߵýʧЧ */
	{
		GPIO_InitTypeDef GPIO_InitStructure;

		/* TIM5 clock enable */
		RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM5, ENABLE);

		/* GPIOH clock enable */
		RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOH, ENABLE);

		/* GPIOH Configuration: PH12  -> TIM5 CH3 */
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
		GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP ;
		GPIO_Init(GPIOH, &GPIO_InitStructure);

		/* Connect TIM5 pins to AF2 */
		GPIO_PinAFConfig(GPIOH, GPIO_PinSource12, GPIO_AF_TIM5);
	}

	{
		TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
		TIM_OCInitTypeDef  TIM_OCInitStructure;
		uint32_t uiTIMxCLK;
		uint16_t usPrescaler;
		uint16_t usPeriod;

		//TIM_DeInit(TIM5);	/* λTIMʱ */

	    /*-----------------------------------------------------------------------
			system_stm32f4xx.c ļ void SetSysClock(void) ʱӵ£

			HCLK = SYSCLK / 1     (AHB1Periph)
			PCLK2 = HCLK / 2      (APB2Periph)
			PCLK1 = HCLK / 4      (APB1Periph)

			ΪAPB1 prescaler != 1,  APB1ϵTIMxCLK = PCLK1 x 2 = SystemCoreClock / 2;
			ΪAPB2 prescaler != 1,  APB2ϵTIMxCLK = PCLK2 x 2 = SystemCoreClock;

			APB1 ʱ TIM2, TIM3 ,TIM4, TIM5, TIM6, TIM6, TIM12, TIM13,TIM14
			APB2 ʱ TIM1, TIM8 ,TIM9, TIM10, TIM11
		*/

		uiTIMxCLK = SystemCoreClock / 2;

		if (_ulFreq < 3000)
		{
			usPrescaler = 100 - 1;					/* Ƶ = 10 */
			usPeriod =  (uiTIMxCLK / 100) / _ulFreq  - 1;		/* Զװֵ */
		}
		else	/* 4KƵʣƵ */
		{
			usPrescaler = 0;					/* Ƶ = 1 */
			usPeriod = uiTIMxCLK / _ulFreq - 1;	/* Զװֵ */
		}

		/* Time base configuration */
		TIM_TimeBaseStructure.TIM_Period = usPeriod;
		TIM_TimeBaseStructure.TIM_Prescaler = usPrescaler;
		TIM_TimeBaseStructure.TIM_ClockDivision = 0;
		TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;

		TIM_TimeBaseInit(TIM5, &TIM_TimeBaseStructure);

		/* PWM1 Mode configuration: Channel1 */
		TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;
		TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
		TIM_OCInitStructure.TIM_Pulse = 4;
		TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_Low;

		TIM_OC3Init(TIM5, &TIM_OCInitStructure);

		TIM_OC3PreloadConfig(TIM5, TIM_OCPreload_Enable);

		TIM_ARRPreloadConfig(TIM5, ENABLE);

		TIM_Cmd(TIM5, ENABLE);
	}

	/* PI6, BUSY Ϊжڣ½ش */
	{
		EXTI_InitTypeDef   EXTI_InitStructure;
		GPIO_InitTypeDef   GPIO_InitStructure;
		NVIC_InitTypeDef   NVIC_InitStructure;

		/* Enable GPIOA clock */
		RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOI, ENABLE);
		/* Enable SYSCFG clock */
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);

		/* Configure PI6 pin as input floating */
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
		GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
		GPIO_Init(GPIOI, &GPIO_InitStructure);

		/* Connect EXTI Line6 to PI6 pin */
		SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOI, EXTI_PinSource6);

		/* Configure EXTI Line6 */
		EXTI_InitStructure.EXTI_Line = EXTI_Line6;
		EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
		EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;

		//EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising;
		EXTI_InitStructure.EXTI_LineCmd = ENABLE;
		EXTI_Init(&EXTI_InitStructure);

		/* Enable and set EXTI Line6 Interrupt to the lowest priority */
		NVIC_InitStructure.NVIC_IRQChannel = EXTI9_5_IRQn;
		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x00;
		NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x00;
		NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
		NVIC_Init(&NVIC_InitStructure);
	}
}

/*
*********************************************************************************************************
*	  : AD7606_HasNewData
*	˵: жFIFOǷ
*	    :  _usReadAdc : ADCıָ
*	  ֵ: 1 ʾУ0ʾ
*********************************************************************************************************
*/
uint8_t AD7606_HasNewData(void)
{
	if (g_tAdcFifo.usCount > 0)
	{
		return 1;
	}
	return 0;
}

/*
*********************************************************************************************************
*	  : AD7606_FifoFull
*	˵: жFIFOǷ
*	    :  _usReadAdc : ADCıָ
*	  ֵ: 1 ʾ0ʾδ
*********************************************************************************************************
*/
uint8_t AD7606_FifoFull(void)
{
	return g_tAdcFifo.ucFull;
}

/*
*********************************************************************************************************
*	  : AD7606_ReadFifo
*	˵: FIFOжȡһADCֵ
*	    :  _usReadAdc : ADCıָ
*	  ֵ: 1 ʾOK0ʾ
*********************************************************************************************************
*/
uint8_t AD7606_ReadFifo(uint16_t *_usReadAdc)
{
	if (AD7606_HasNewData())
	{
		*_usReadAdc = g_tAdcFifo.sBuf[g_tAdcFifo.usRead];
		if (++g_tAdcFifo.usRead >= ADC_FIFO_SIZE)
		{
			g_tAdcFifo.usRead = 0;
		}

		DISABLE_INT();
		if (g_tAdcFifo.usCount > 0)
		{
			g_tAdcFifo.usCount--;
		}
		ENABLE_INT();
		return 1;
	}
	return 0;
}

/*
*********************************************************************************************************
*	  : AD7606_StartRecord
*	˵: ʼɼ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_StartRecord(uint32_t _ulFreq)
{
	AD7606_StopRecord();

	AD7606_Reset();					/* λӲ */
	AD7606_StartConvst();			/* 1ȫ0 */

	g_tAdcFifo.usRead = 0;			/* ڿTIM2֮ǰ0 */
	g_tAdcFifo.usWrite = 0;
	g_tAdcFifo.usCount = 0;
	g_tAdcFifo.ucFull = 0;

	AD7606_EnterAutoMode(_ulFreq);
}

/*
*********************************************************************************************************
*	  : AD7606_StopRecord
*	˵: ֹͣɼʱ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_StopRecord(void)
{
	TIM_Cmd(TIM5, DISABLE);

	/* PH12 Ϊͨ */
	{
		GPIO_InitTypeDef GPIO_InitStructure;

		/* ʹ GPIOʱ */
		RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOH, ENABLE);

		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
		GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL;

		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
		GPIO_Init(GPIOH, &GPIO_InitStructure);
	}

	/* PI6, ֹ BUSY Ϊж */
	{
		EXTI_InitTypeDef   EXTI_InitStructure;

		/* Configure EXTI Line6 */
		EXTI_InitStructure.EXTI_Line = EXTI_Line6;
		EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
		EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;
		EXTI_InitStructure.EXTI_LineCmd = DISABLE;
		EXTI_Init(&EXTI_InitStructure);
	}
	CONVST_1();					/* תGPIOƽʱΪ */

}

/*
*********************************************************************************************************
*	  : AD7606_ISR
*	˵: ʱɼжϷ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_ISR(void)
{
	uint8_t i;

	AD7606_ReadNowAdc();

	for (i = 0; i < 8; i++)
	{
		g_tAdcFifo.sBuf[g_tAdcFifo.usWrite] = g_tAD7606.sNowAdc[i];
		if (++g_tAdcFifo.usWrite >= ADC_FIFO_SIZE)
		{
			g_tAdcFifo.usWrite = 0;
		}
		if (g_tAdcFifo.usCount < ADC_FIFO_SIZE)
		{
			g_tAdcFifo.usCount++;
		}
		else
		{
			g_tAdcFifo.ucFull = 1;		/* FIFO  */
		}
	}
}

/*
*********************************************************************************************************
*	  : EXTI9_5_IRQHandler
*	˵: ⲿжϷڡPI6 / AD7606_BUSY ½жϴ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
#ifndef EXTI9_5_ISR_MOVE_OUT		/* bsp.h жУʾƵ stam32f4xx_it.c ظ */
void EXTI9_5_IRQHandler(void)
{
	if (EXTI_GetITStatus(EXTI_Line6) != RESET)
	{
		AD7606_ISR();

		/* Clear the EXTI line 6 pending bit */
		EXTI_ClearITPendingBit(EXTI_Line6);
	}
}
#endif

/*****************************  www.armfly.com (END OF FILE) *********************************/
