/*
*********************************************************************************************************
*
*	ģ : նȴBH1750FVIģ
*	ļ : bsp_bh1750.c
*	     : V1.0
*	˵     : ʵBH1750FVIĶд
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-02-01 armfly  ʽ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

/*
	Ӧ˵:BH1750ǰȵһ bsp_InitI2C()úI2CصGPIO.

	ն lx
	տ˹ (Lux) 壬ùԴ1״1m2ϵõĹͨ1lmʱն1lux

	նȿնȼֱӲնȵĵλտ˹Ӣlux룬ҲдΪlx
	壬1ƽϵõĹͨ1ʱն1տ˹ʱΪ˳ùԴ
	ڹԴϸһװãʹĳЩܹõȽ϶Ĺͨһϵնȡ
	ǰơֵͲӰƵȡ

	Ǹֻնֵλlux
	ҹ0.0010.02
	ҹ0.020.3
	ڣ550
	⣺50500
	ڣ1001000
	ļ̫µնȣԼΪ10*9
	Ķ鿯ʱնȣ5060
	׼նȣ1400

	BH1750FVI ΪնȲоƬ̿ͨеڡ
	С 0.11 lux  100000 lux

*/

#include "bsp.h"

static uint8_t s_MTReg;	/* ȱ */
static uint8_t s_Mode;	/* ģʽ */
/*
*********************************************************************************************************
*	  : bsp_InitBH1750
*	˵: ʼBH1750
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitBH1750(void)
{
	BH1750_WriteCmd(BHOP_POWER_ON);		/* оƬϵ */

	BH1750_ChageMode(2);			/* ߷ֱ */
	
	BH1750_AdjustSensitivity(69);	/* оƬȱʡȱ = 69 */
}

/*
*********************************************************************************************************
*	  : BH1750_WriteCmd
*	˵: оƬ1ֽڳȵĲ
*	    : _ucOpecode : Ĵַ
*	  ֵ: 
*********************************************************************************************************
*/
void BH1750_WriteCmd(uint8_t _ucOpecode)
{
    i2c_Start();							/* ߿ʼź */

    i2c_SendByte(BH1750_SLAVE_ADDRESS);		/* 豸ַ+дź */
	i2c_WaitAck();

    i2c_SendByte(_ucOpecode);				/* 1ֽڲ */
	i2c_WaitAck();

    i2c_Stop();                   			/* ֹͣź */
}

/*
*********************************************************************************************************
*	  : BH1750_AdjustSensitivity
*	˵: BH1750
*	    : _ucMTReg : ̱.  ֵ31254ֵԽ Խ
*	  ֵ: 
*********************************************************************************************************
*/
void BH1750_AdjustSensitivity(uint8_t _ucMTReg)
{
	if (_ucMTReg <= 31)
	{
		_ucMTReg = 31;
	}
	else if (_ucMTReg >= 254)
	{
		_ucMTReg = 254;
	}
	
	s_MTReg = _ucMTReg;
	
	BH1750_WriteCmd(0x40 + (s_MTReg >> 5));		/* ĸ3bit */
	BH1750_WriteCmd(0x60 + (s_MTReg & 0x1F));	/* ĵ5bit */
	
	/*̷ΧҪ·òģʽ*/
	BH1750_ChageMode(s_Mode);
}

/*
*********************************************************************************************************
*	  : BH1750_ChageMode
*	˵: ޸BH1750ģʽֱ 
*	    : __ucMode : ģʽ ֵ(123)
*	  ֵ: 
*********************************************************************************************************
*/
void BH1750_ChageMode(uint8_t _ucMode)
{
	if (_ucMode == 1)		/* ߷ֲģʽ1 */
	{
		BH1750_WriteCmd(BHOP_CON_H_RES);	
		s_Mode = 1;			/* ģʽ1ֱ 1 lux*/
	}
	else if (_ucMode == 2)	/* ߷ֲģʽ2 */
	{
		BH1750_WriteCmd(BHOP_CON_H_RES2);	
		s_Mode = 2;			/* ģʽ2, ֱ 0.5 lux */		
	}
	else if (_ucMode == 3)	/* ͷֲģʽ */
	{
		BH1750_WriteCmd(BHOP_CON_L_RES);	
		s_Mode = 3;			/* ģʽ3ͷֱ 4 lux*/		
	}	
}

/*
*********************************************************************************************************
*	  : BH1750_ReadData
*	˵: ȡBH1750.  Ҫ bsp_InitBH1750() ִ֮ 180ms ܶȷݡ
*			  ģʽ£֮ԶʱñȡǿݣʱҪ180ms
*	    : 
*	  ֵ: ԭʼĲ ,δת
*********************************************************************************************************
*/
uint16_t BH1750_ReadData(void)
{
	uint8_t ucData1;
	uint8_t ucData2;
	uint16_t usLight;

	i2c_Start();                  			/* ߿ʼź */
	i2c_SendByte(BH1750_SLAVE_ADDRESS + 1);	/* 豸ַ+ź */
	i2c_WaitAck();

	ucData1 = i2c_ReadByte();       		/* ֽ */
	i2c_Ack();
	ucData2 = i2c_ReadByte();       		/* ֽ */
	i2c_NAck();
	i2c_Stop();                  			/* ֹͣź */
	
	usLight = (ucData1 << 8) + ucData2;

	return usLight;
}

/*
*********************************************************************************************************
*	  : BH1750_GetLux
*	˵: ȡBH1750, תΪ Luxλ
*	    : 
*	  ֵ: ǿ [Lux]  
*********************************************************************************************************
*/
float BH1750_GetLux(void)
{
	uint16_t usLight;
	float lux;
	
	usLight = BH1750_ReadData();
	
	/* ǿ = 16λĴֵ / 1.2  * (69 / X) */

	//lux = usLight * (((float)1 / 1.2) * ((float)69 / s_MTReg));
	lux = (float)(usLight * 5 * 69) / (6 * s_MTReg);
	
	if (s_Mode == 2)	/* ߷ֱʲģʽ2 */
	{
		lux = lux / 2;
	}
	else
	{
		;	/* س2 */
	}
	
	return lux;
}


/*****************************  www.armfly.com (END OF FILE) *********************************/
