/*
*********************************************************************************************************
*
*	ģ : DS18B20 ģ(1-wire ¶ȴ
*	ļ : bsp_ds18b20.c
*	     : V1.0
*	˵     : DS18B20CPU֮1GPIOӿڡ
*
*	޸ļ¼ :
*		汾                ˵
*		V1.0    2014-01-24  armfly  ʽ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

/*
	DS18B20 ֱӲ鵽STM32-V5U16 (3P) .

    DS18B20     STM32F407
	  VCC   ------  3.3V
	  DQ    ------  PB1   ( 4.7K )
	  GND   ------  GND
*/

/* GPIO˿ */
#define RCC_DQ		RCC_AHB1Periph_GPIOB
#define PORT_DQ		GPIOB
#define PIN_DQ		GPIO_Pin_1

#if 0 /* ⺯ʽ */
	#define DQ_0()		GPIO_ResetBits(PORT_DQ, PIN_DQ)
	#define DQ_1()		GPIO_SetBits(PORT_DQ, PIN_DQ)

	/* жDQǷΪ */
	#define DQ_IS_LOW()	(GPIO_ReadInputDataBit(PORT_DQ, PIN_DQ) == Bit_RESET)
#else	/* ֱӲĴٶ */
	#define DQ_0()		PORT_DQ->BSRRH = PIN_DQ
	#define DQ_1()		PORT_DQ->BSRRL = PIN_DQ

	/* жDQǷΪ */
	#define DQ_IS_LOW()	((PORT_DQ->IDR & PIN_DQ) == 0)
#endif

/*
*********************************************************************************************************
*	  : bsp_InitDS18B20
*	˵: STM32GPIOSPIӿڣ DS18B20
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitDS18B20(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	/* GPIOʱ */
	RCC_AHB1PeriphClockCmd(RCC_DQ, ENABLE);

	DQ_1();

	/* DQΪ© */
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;		/* Ϊ */
	GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;		/* Ϊ©ģʽ */
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	/* 費ʹ */
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;	/* IOٶ */

	GPIO_InitStructure.GPIO_Pin = PIN_DQ;
	GPIO_Init(PORT_DQ, &GPIO_InitStructure);
}

/*
*********************************************************************************************************
*	  : DS18B20_Reset
*	˵: λDS18B20 DQΪͣ480usȻȴ
*	    : 
*	  ֵ: 0 ʧܣ 1 ʾɹ
*********************************************************************************************************
*/
uint8_t DS18B20_Reset(void)
{
	/*
		λʱ, DS18B20 page 15

		DQ 480us
		ȻͷDQȴDQߣԼ 15-60us
		DS18B20 DQΪ 60-240us źŽ presence pulse  (λ,ʾDS18B20׼ Խ)
		⵽ӦźţʾDS18B20λɹ
	*/

	uint8_t i;
	uint16_t k;

	DISABLE_INT();/* ֹȫж */

	/* λʧ򷵻0 */
	for (i = 0; i < 1; i++)
	{
		DQ_0();				/* DQ */
		bsp_DelayUS(520);	/* ӳ 520uS Ҫӳٴ 480us */
		DQ_1();				/* ͷDQ */

		bsp_DelayUS(15);	/* ȴ15us */

		/* DQƽǷΪ */
		for (k = 0; k < 10; k++)
		{
			if (DQ_IS_LOW())
			{
				break;
			}
			bsp_DelayUS(10);	/* ȴ65us */
		}
		if (k >= 10)
		{
			continue;		/* ʧ */
		}

		/* ȴDS18B20ͷDQ */
		for (k = 0; k < 30; k++)
		{
			if (!DQ_IS_LOW())
			{
				break;
			}
			bsp_DelayUS(10);	/* ȴ65us */
		}
		if (k >= 30)
		{
			continue;		/* ʧ */
		}

		break;
	}

	ENABLE_INT();	/* ʹȫж */

	bsp_DelayUS(5);

	if (i >= 1)
	{
		return 0;
	}

	return 1;
}

/*
*********************************************************************************************************
*	  : DS18B20_WriteByte
*	˵: DS18B20д1ֽ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void DS18B20_WriteByte(uint8_t _val)
{
	/*
		дʱ, DS18B20 page 16
	*/
	uint8_t i;

	for (i = 0; i < 8; i++)
	{
		DQ_0();
		bsp_DelayUS(2);

		if (_val & 0x01)
		{
			DQ_1();
		}
		else
		{
			DQ_0();
		}
		bsp_DelayUS(60);
		DQ_1();
		bsp_DelayUS(2);
		_val >>= 1;
	}
}

/*
*********************************************************************************************************
*	  : DS18B20_ReadByte
*	˵: DS18B20ȡ1ֽ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static uint8_t DS18B20_ReadByte(void)
{
	/*
		дʱ, DS18B20 page 16
	*/
	uint8_t i;
	uint8_t read = 0;

	for (i = 0; i < 8; i++)
	{
		read >>= 1;

		DQ_0();
		bsp_DelayUS(3);
		DQ_1();
		bsp_DelayUS(3);

		if (DQ_IS_LOW())
		{
			;
		}
		else
		{
			read |= 0x80;
		}
		bsp_DelayUS(60);
	}

	return read;
}

/*
*********************************************************************************************************
*	  : DS18B20_ReadTempReg
*	˵: ¶ȼĴֵԭʼݣ
*	    : 
*	  ֵ: ¶ȼĴ 16õ 1϶ȵλ, ҲСǰ)
*********************************************************************************************************
*/
int16_t DS18B20_ReadTempReg(void)
{
	uint8_t temp1, temp2;

	/* ߸λ */
	if (DS18B20_Reset() == 0)
	{
		return 0;
	}		

	DS18B20_WriteByte(0xcc);	/*  */
	DS18B20_WriteByte(0x44);	/* ת */

	DS18B20_Reset();		/* ߸λ */

	DS18B20_WriteByte(0xcc);	/*  */
	DS18B20_WriteByte(0xbe);

	temp1 = DS18B20_ReadByte();	/* ¶ֵֽ */
	temp2 = DS18B20_ReadByte();	/* ¶ֵֽ */

	return ((temp2 << 8) | temp1);	/* 16λĴֵ */
}

/*
*********************************************************************************************************
*	  : DS18B20_ReadID
*	˵: DS18B20ROM ID ϱֻ1оƬ
*	    : _id 洢ID
*	  ֵ: 0 ʾʧܣ 1ʾ⵽ȷID
*********************************************************************************************************
*/
uint8_t DS18B20_ReadID(uint8_t *_id)
{
	uint8_t i;

	/* ߸λ */
	if (DS18B20_Reset() == 0)
	{
		return 0;
	}

	DS18B20_WriteByte(0x33);	/*  */
	for (i = 0; i < 8; i++)
	{
		_id[i] = DS18B20_ReadByte();
	}

	DS18B20_Reset();		/* ߸λ */
	
	return 1;
}

/*
*********************************************************************************************************
*	  : DS18B20_ReadTempByID
*	˵: ָID¶ȼĴֵԭʼݣ
*	    : 
*	  ֵ: ¶ȼĴ 16õ 1϶ȵλ, ҲСǰ)
*********************************************************************************************************
*/
int16_t DS18B20_ReadTempByID(uint8_t *_id)
{
	uint8_t temp1, temp2;
	uint8_t i;

	DS18B20_Reset();		/* ߸λ */

	DS18B20_WriteByte(0x55);	/*  */
	for (i = 0; i < 8; i++)
	{
		DS18B20_WriteByte(_id[i]);
	}
	DS18B20_WriteByte(0x44);	/* ת */

	DS18B20_Reset();		/* ߸λ */

	DS18B20_WriteByte(0x55);	/*  */
	for (i = 0; i < 8; i++)
	{
		DS18B20_WriteByte(_id[i]);
	}	
	DS18B20_WriteByte(0xbe);

	temp1 = DS18B20_ReadByte();	/* ¶ֵֽ */
	temp2 = DS18B20_ReadByte();	/* ¶ֵֽ */

	return ((temp2 << 8) | temp1);	/* 16λĴֵ */
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
