/*
*********************************************************************************************************
*
*	ģ : I2Cģ
*	ļ : bsp_i2c_gpio.c
*	     : V1.0
*	˵     : gpioģi2c, STM32F4ϵCPUģ鲻Ӧò֡I2C߻
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-02-01 armfly  ʽ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

/*
	Ӧ˵
	ڷI2C豸ǰȵ i2c_CheckDevice() I2C豸ǷúGPIO
*/

#include "bsp.h"

/*
	STM32-V5 i2cGPIO:
 		PH4/I2C2_SCL
 		PH5/I2C2_SDA
*/

/* I2CӵGPIO˿, ûֻҪ޸4д뼴ıSCLSDA */
#define GPIO_PORT_I2C	GPIOH			/* GPIO˿ */
#define RCC_I2C_PORT 	RCC_AHB1Periph_GPIOH		/* GPIO˿ʱ */
#define I2C_SCL_PIN		GPIO_Pin_4			/* ӵSCLʱߵGPIO */
#define I2C_SDA_PIN		GPIO_Pin_5			/* ӵSDAߵGPIO */

/* дSCLSDAĺ */
#define I2C_SCL_1()  GPIO_PORT_I2C->BSRRL = I2C_SCL_PIN				/* SCL = 1 */
#define I2C_SCL_0()  GPIO_PORT_I2C->BSRRH = I2C_SCL_PIN				/* SCL = 0 */

#define I2C_SDA_1()  GPIO_PORT_I2C->BSRRL = I2C_SDA_PIN				/* SDA = 1 */
#define I2C_SDA_0()  GPIO_PORT_I2C->BSRRH = I2C_SDA_PIN				/* SDA = 0 */

#define I2C_SDA_READ()  ((GPIO_PORT_I2C->IDR & I2C_SDA_PIN) != 0)	/* SDA״̬ */
#define I2C_SCL_READ()  ((GPIO_PORT_I2C->IDR & I2C_SCL_PIN) != 0)	/* SCL״̬ */

/*
*********************************************************************************************************
*	  : bsp_InitI2C
*	˵: I2CߵGPIOģIOķʽʵ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitI2C(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	RCC_AHB1PeriphClockCmd(RCC_I2C_PORT, ENABLE);	/* GPIOʱ */

	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;		/* Ϊ */
	GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;		/* Ϊ©ģʽ */
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	/* 費ʹ */
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;	/* IOٶ */

	GPIO_InitStructure.GPIO_Pin = I2C_SCL_PIN | I2C_SDA_PIN;
	GPIO_Init(GPIO_PORT_I2C, &GPIO_InitStructure);

	/* һֹͣź, λI2Cϵ豸ģʽ */
	i2c_Stop();
}

/*
*********************************************************************************************************
*	  : i2c_Delay
*	˵: I2Cλӳ٣400KHz
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void i2c_Delay(void)
{
	uint8_t i;

	/*
		CPUƵ168MHzʱڲFlash, MDK̲Ż̨ʽʾ۲ⲨΡ
		ѭΪ5ʱSCLƵ = 1.78MHz (ʱ: 92ms, дʾ̽ͷϾͶдʧܡʱӽٽ)
		ѭΪ10ʱSCLƵ = 1.1MHz (ʱ: 138ms, ٶ: 118724B/s)
		ѭΪ30ʱSCLƵ = 440KHz SCLߵƽʱ1.0usSCL͵ƽʱ1.2us

		ѡ2.2KŷʱSCLʱԼ0.5usѡ4.7KŷԼ1us

		ʵӦѡ400KHzҵʼ
	*/
	for (i = 0; i < 30; i++);
}

/*
*********************************************************************************************************
*	  : i2c_Start
*	˵: CPUI2Cź
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_Start(void)
{
	/* SCLߵƽʱSDAһرʾI2Cź */
	I2C_SDA_1();
	I2C_SCL_1();
	i2c_Delay();
	I2C_SDA_0();
	i2c_Delay();
	I2C_SCL_0();
	i2c_Delay();
}

/*
*********************************************************************************************************
*	  : i2c_Start
*	˵: CPUI2Cֹͣź
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_Stop(void)
{
	/* SCLߵƽʱSDAһرʾI2Cֹͣź */
	I2C_SDA_0();
	I2C_SCL_1();
	i2c_Delay();
	I2C_SDA_1();
}

/*
*********************************************************************************************************
*	  : i2c_SendByte
*	˵: CPUI2C豸8bit
*	    :  _ucByte  ȴ͵ֽ
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_SendByte(uint8_t _ucByte)
{
	uint8_t i;

	/* ȷֽڵĸλbit7 */
	for (i = 0; i < 8; i++)
	{
		if (_ucByte & 0x80)
		{
			I2C_SDA_1();
		}
		else
		{
			I2C_SDA_0();
		}
		i2c_Delay();
		I2C_SCL_1();
		i2c_Delay();
		I2C_SCL_0();
		if (i == 7)
		{
			 I2C_SDA_1(); // ͷ
		}
		_ucByte <<= 1;	/* һbit */
		i2c_Delay();
	}
}

/*
*********************************************************************************************************
*	  : i2c_ReadByte
*	˵: CPUI2C豸ȡ8bit
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
uint8_t i2c_ReadByte(void)
{
	uint8_t i;
	uint8_t value;

	/* 1bitΪݵbit7 */
	value = 0;
	for (i = 0; i < 8; i++)
	{
		value <<= 1;
		I2C_SCL_1();
		i2c_Delay();
		if (I2C_SDA_READ())
		{
			value++;
		}
		I2C_SCL_0();
		i2c_Delay();
	}
	return value;
}

/*
*********************************************************************************************************
*	  : i2c_WaitAck
*	˵: CPUһʱӣȡACKӦź
*	    :  
*	  ֵ: 0ʾȷӦ1ʾӦ
*********************************************************************************************************
*/
uint8_t i2c_WaitAck(void)
{
	uint8_t re;

	I2C_SDA_1();	/* CPUͷSDA */
	i2c_Delay();
	I2C_SCL_1();	/* CPUSCL = 1, ʱ᷵ACKӦ */
	i2c_Delay();
	if (I2C_SDA_READ())	/* CPUȡSDA״̬ */
	{
		re = 1;
	}
	else
	{
		re = 0;
	}
	I2C_SCL_0();
	i2c_Delay();
	return re;
}

/*
*********************************************************************************************************
*	  : i2c_Ack
*	˵: CPUһACKź
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_Ack(void)
{
	I2C_SDA_0();	/* CPUSDA = 0 */
	i2c_Delay();
	I2C_SCL_1();	/* CPU1ʱ */
	i2c_Delay();
	I2C_SCL_0();
	i2c_Delay();
	I2C_SDA_1();	/* CPUͷSDA */
}

/*
*********************************************************************************************************
*	  : i2c_NAck
*	˵: CPU1NACKź
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_NAck(void)
{
	I2C_SDA_1();	/* CPUSDA = 1 */
	i2c_Delay();
	I2C_SCL_1();	/* CPU1ʱ */
	i2c_Delay();
	I2C_SCL_0();
	i2c_Delay();
}

/*
*********************************************************************************************************
*	  : i2c_CheckDevice
*	˵: I2C豸CPU豸ַȻȡ豸Ӧжϸ豸Ƿ
*	    :  _Address豸I2Cߵַ
*	  ֵ: ֵ 0 ʾȷ 1ʾδ̽⵽
*********************************************************************************************************
*/
uint8_t i2c_CheckDevice(uint8_t _Address)
{
	uint8_t ucAck;

	if (I2C_SDA_READ() && I2C_SCL_READ())
	{
		i2c_Start();		/* ź */

		/* 豸ַ+дbit0 = w 1 = r) bit7 ȴ */
		i2c_SendByte(_Address | I2C_WR);
		ucAck = i2c_WaitAck();	/* 豸ACKӦ */

		i2c_Stop();			/* ֹͣź */

		return ucAck;
	}
	return 1;	/* I2C쳣 */
}
