/*
*********************************************************************************************************
*	                                  
*	ģ : Ź
*	ļ : bsp_iwdg.c
*	     : V1.0
*	˵     : IWDG
*	޸ļ¼ :
*		汾                ˵
*		V1.0    2013-12-02  armfly   ʽ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/
#include "bsp.h"
#include "stdio.h"
#include "stdlib.h"

__IO uint32_t LsiFreq = 0;
__IO uint32_t CaptureNumber = 0, PeriodValue = 0;
uint32_t GetLSIFrequency(void);
/*
*********************************************************************************************************
*	  : bsp_InitIwdg
*	˵: Źʱú
*	    ΣIWDGTime: 0 ---- 0x0FFF
*			  Źʱ,λΪms,IWDGTime = 1000 Լһ
*             ʱ䣬ûнTIM5ʵLSIƵʣֻΪ˲ȡ
*             һֵIWDGTimeιĻϵͳḴλ
*			  LSI = 34000
*	  ֵ: 		        
*********************************************************************************************************
*/
void bsp_InitIwdg(uint32_t _ulIWDGTime)
{
		
	/* ϵͳǷӶŹλлָ */
	if (RCC_GetFlagStatus(RCC_FLAG_IWDGRST) != RESET)
	{		
		/* λ־ */
		RCC_ClearFlag();
	}
	else
	{
		/* ־û */

	}
	
#if 1
	/* ͨTIM5벶õLSIƵ */
	LsiFreq = GetLSIFrequency();
#else
	/* ʹLSI */
	RCC_LSICmd(ENABLE);
	
	/* ȴֱLSI */
	while (RCC_GetFlagStatus(RCC_FLAG_LSIRDY) == RESET)
	{}
	
    /* */		
	LsiFreq = 32000;
#endif
	
	/* д0x5555ʾIWDG_PR IWDG_RLRĴ */
	IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);
	
	/*  LSI/32 Ƶ*/
	IWDG_SetPrescaler(IWDG_Prescaler_32);
	
	/*رע⣬_ulIWDGTimeСλms, װ
	  ʱ Ҫ1000
	 Counter Reload Value = (_ulIWDGTime / 1000) /(1 / IWDG counter clock period)
	                      = (_ulIWDGTime / 1000) / (32/LSI)
	                      = (_ulIWDGTime / 1000) / (32/LsiFreq)
	                      = LsiFreq * _ulIWDGTime / 32000
	 ʵʲLsiFreq = 34000ȡ1ʱ ž1ms 
	*/
	IWDG_SetReload(_ulIWDGTime);
	
	/* IWDG */
	IWDG_ReloadCounter();
	
	/* ʹ IWDG (LSI oscillator Ӳʹ) */
	IWDG_Enable();		
}

/*
*********************************************************************************************************
*	  : IWDG_Feed
*	˵: ι
*	    Σ
*	  ֵ: 		        
*********************************************************************************************************
*/
void IWDG_Feed(void)
{
	IWDG_ReloadCounter();
}

/*
*********************************************************************************************************
*	  : GetLSIFrequency
*	˵: TIM5ͨ4LSIƵ
*	    Σ
*	  ֵ: LSI Frequency	 ʵʲLSI = 34000,ֲķΧ	        
*********************************************************************************************************
*/
uint32_t GetLSIFrequency(void)
{
	NVIC_InitTypeDef   NVIC_InitStructure;
	TIM_ICInitTypeDef  TIM_ICInitStructure;
	RCC_ClocksTypeDef  RCC_ClockFreq;
	
	/* ʹⲿپ */
	RCC_LSICmd(ENABLE);
	
	/* ȴֱLSI */
	while (RCC_GetFlagStatus(RCC_FLAG_LSIRDY) == RESET)
	{}
	
	/* TIM5  */ 
	/* ʹTIM5ʱ */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM5, ENABLE);
	
	/* TIM5_CH4벶ͨӵLSIʱ */
	TIM_RemapConfig(TIM5, TIM5_LSI);
	
	/* TIM5Ƶ */
	TIM_PrescalerConfig(TIM5, 0, TIM_PSCReloadMode_Immediate);
	
	/* 
	 TIM5 : 벶ģʽ 
	 1. LSI ӵ TIM5 CH4
	 2. Ϊı
	 3. TIM5 CCR4ڼƵֵ 
	 4. ҪƵTIM_ICPSC_DIV8˼TIM8Ƶ
		˼ÿ8ʱ䲶һΣͱʾ8Ժ
		һβжϣȻٹ8زһνжϣ
		жԺõʱҲ8ڣõĽ
		ǷŴ8
    */
	TIM_ICInitStructure.TIM_Channel = TIM_Channel_4;
	TIM_ICInitStructure.TIM_ICPolarity = TIM_ICPolarity_Rising;
	TIM_ICInitStructure.TIM_ICSelection = TIM_ICSelection_DirectTI;
	TIM_ICInitStructure.TIM_ICPrescaler = TIM_ICPSC_DIV8;
	TIM_ICInitStructure.TIM_ICFilter = 0;
	TIM_ICInit(TIM5, &TIM_ICInitStructure);
	
	/* ʹTIM5жͨ */
	NVIC_InitStructure.NVIC_IRQChannel = TIM5_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
	
	/* ʹTIM5 */
	TIM_Cmd(TIM5, ENABLE);
	
	/* ־ */
	TIM5->SR = 0;
	
	/* ʹ CC4 ж */  
	TIM_ITConfig(TIM5, TIM_IT_CC4, ENABLE);
	
	
	/* ȴֱ TIM5 õ 2 LSI  */
	while(CaptureNumber != 2)
	{
		
	}
	
	/* ضTIM5λֵ */
	TIM_DeInit(TIM5);
		
	/*  LSI Ƶ, TIM5ʱƵ(PCLK1)*/
	/* õ SYSCLK, HCLK  PCLKx  */
	RCC_GetClocksFreq(&RCC_ClockFreq);
	
	/*
	  HCLK = SYSCLK / 1     (AHB1Periph)     = 168MHz
      PCLK2 = HCLK / 2      (APB2Periph)      = 84MHz
      PCLK1 = HCLK / 4      (APB1Periph)      = 42MHz
    
      ΪAPB1 prescaler != 1,  APB1ϵTIMxCLK = PCLK1 x 2 = SystemCoreClock / 2;
      ΪAPB2 prescaler != 1,  APB2ϵTIMxCLK = PCLK2 x 2 = SystemCoreClock;

      APB1 ʱ TIM2, TIM3 ,TIM4, TIM5, TIM6, TIM6, TIM12, TIM13,TIM14
      APB2 ʱ TIM1, TIM8 ,TIM9, TIM10, TIM11
	*/
	if ((RCC->CFGR & RCC_CFGR_PPRE1) == 0)
	{   
		/* PCLK1 prescaler == 1 ô TIMCLK = PCLK1 */
		return ((RCC_ClockFreq.PCLK1_Frequency / PeriodValue)*8);
		
	}
	else
	{   
		/* 
		  PCLK1 prescaler  1 ô TIMCLK = 2 * PCLK1
		  ó8Ϊǰÿ8¼һβ
		*/
		return (((2 * RCC_ClockFreq.PCLK1_Frequency) / PeriodValue)*8) ;
		
	}
}




