/*
*********************************************************************************************************
*
*	ģ : LEDָʾģ
*	ļ : bsp_led.c
*	     : V1.0
*	˵     : LEDָʾ
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-02-01 armfly  ʽ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

/*
	óڰSTM32-X4STM32-F4

	Ӳ޸GPIO IsKeyDown1 - IsKeyDown8 

	ûLEDָʾƸС4ԽLEDȫΪ͵1LEDһӰ
*/

#ifdef STM32_X3		/*  STM32-X4  */
	/*
		STM32-X4 LED߷䣺
			LED1       : PE2 (͵ƽߵƽϨ)
			LED2       : PE3 (͵ƽߵƽϨ)
			LED3       : PE4 (͵ƽߵƽϨ)
			LED4       : PE5 (͵ƽߵƽϨ)
	*/
	#define RCC_ALL_LED 	RCC_AHB1Periph_GPIOE	/* ڶӦRCCʱ */

	#define GPIO_PORT_LED1  GPIOE
	#define GPIO_PIN_LED1	GPIO_Pin_2

	#define GPIO_PORT_LED2  GPIOE
	#define GPIO_PIN_LED2	GPIO_Pin_3

	#define GPIO_PORT_LED3  GPIOE
	#define GPIO_PIN_LED3	GPIO_Pin_4

	#define GPIO_PORT_LED4  GPIOE
	#define GPIO_PIN_LED4	GPIO_Pin_5

#else	/* STM32_F4 */
	/*
		STM32-V5 LED߷䣺
			LD1     : PI10/TP_NCS          (͵ƽߵƽϨ)
			LD2     : PF7/NRF24L01_CSN     (͵ƽߵƽϨ)
			LD3     : PF8/SF_CS            (͵ƽߵƽϨ)
			LD4     : PC2/NRF905_CSN/VS1053_XCS  (͵ƽߵƽϨ)
	*/

	/* ڶӦRCCʱ */
	#define RCC_ALL_LED 	(RCC_AHB1Periph_GPIOC | RCC_AHB1Periph_GPIOF | RCC_AHB1Periph_GPIOI)

	#define GPIO_PORT_LED1  GPIOI
	#define GPIO_PIN_LED1	GPIO_Pin_10

	#define GPIO_PORT_LED2  GPIOF
	#define GPIO_PIN_LED2	GPIO_Pin_7

	#define GPIO_PORT_LED3  GPIOF
	#define GPIO_PIN_LED3	GPIO_Pin_8

	#define GPIO_PORT_LED4  GPIOC
	#define GPIO_PIN_LED4	GPIO_Pin_2
#endif

/*
*********************************************************************************************************
*	  : bsp_InitLed
*	˵: LEDָʾصGPIO,  ú bsp_Init() á
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitLed(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	/* GPIOʱ */
	RCC_AHB1PeriphClockCmd(RCC_ALL_LED, ENABLE);

	/*
		еLEDָʾGPIOΪģʽ
		ڽGPIOΪʱGPIOĴֵȱʡ0˻LED.
		ҲϣģڸıGPIOΪǰȹرLEDָʾ
	*/
	bsp_LedOff(1);
	bsp_LedOff(2);
	bsp_LedOff(3);
	bsp_LedOff(4);

	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;		/* Ϊ */
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;		/* Ϊģʽ */
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	/* 費ʹ */
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;	/* IOٶ */

	GPIO_InitStructure.GPIO_Pin = GPIO_PIN_LED1;
	GPIO_Init(GPIO_PORT_LED1, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_PIN_LED2;
	GPIO_Init(GPIO_PORT_LED2, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_PIN_LED3;
	GPIO_Init(GPIO_PORT_LED3, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_PIN_LED4;
	GPIO_Init(GPIO_PORT_LED4, &GPIO_InitStructure);
}

/*
*********************************************************************************************************
*	  : bsp_LedOn
*	˵: ָLEDָʾơ
*	    :  _no : ָʾţΧ 1 - 4
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_LedOn(uint8_t _no)
{
	_no--;

	if (_no == 0)
	{
		GPIO_PORT_LED1->BSRRH = GPIO_PIN_LED1;
	}
	else if (_no == 1)
	{
		GPIO_PORT_LED2->BSRRH = GPIO_PIN_LED2;
	}
	else if (_no == 2)
	{
		GPIO_PORT_LED3->BSRRH = GPIO_PIN_LED3;
	}
	else if (_no == 3)
	{
		GPIO_PORT_LED4->BSRRH = GPIO_PIN_LED4;
	}
}

/*
*********************************************************************************************************
*	  : bsp_LedOff
*	˵: ϨָLEDָʾơ
*	    :  _no : ָʾţΧ 1 - 4
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_LedOff(uint8_t _no)
{
	_no--;

	if (_no == 0)
	{
		GPIO_PORT_LED1->BSRRL = GPIO_PIN_LED1;
	}
	else if (_no == 1)
	{
		GPIO_PORT_LED2->BSRRL = GPIO_PIN_LED2;
	}
	else if (_no == 2)
	{
		GPIO_PORT_LED3->BSRRL = GPIO_PIN_LED3;
	}
	else if (_no == 3)
	{
		GPIO_PORT_LED4->BSRRL = GPIO_PIN_LED4;
	}
}

/*
*********************************************************************************************************
*	  : bsp_LedToggle
*	˵: תָLEDָʾơ
*	    :  _no : ָʾţΧ 1 - 4
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_LedToggle(uint8_t _no)
{
	if (_no == 1)
	{
		GPIO_PORT_LED1->ODR ^= GPIO_PIN_LED1;
	}
	else if (_no == 2)
	{
		GPIO_PORT_LED2->ODR ^= GPIO_PIN_LED2;
	}
	else if (_no == 3)
	{
		GPIO_PORT_LED3->ODR ^= GPIO_PIN_LED3;
	}
	else if (_no == 4)
	{
		GPIO_PORT_LED4->ODR ^= GPIO_PIN_LED4;
	}
}

/*
*********************************************************************************************************
*	  : bsp_IsLedOn
*	˵: жLEDָʾǷѾ
*	    :  _no : ָʾţΧ 1 - 4
*	  ֵ: 1ʾѾ0ʾδ
*********************************************************************************************************
*/
uint8_t bsp_IsLedOn(uint8_t _no)
{
	if (_no == 1)
	{
		if ((GPIO_PORT_LED1->ODR & GPIO_PIN_LED1) == 0)
		{
			return 1;
		}
		return 0;
	}
	else if (_no == 2)
	{
		if ((GPIO_PORT_LED2->ODR & GPIO_PIN_LED2) == 0)
		{
			return 1;
		}
		return 0;
	}
	else if (_no == 3)
	{
		if ((GPIO_PORT_LED3->ODR & GPIO_PIN_LED3) == 0)
		{
			return 1;
		}
		return 0;
	}
	else if (_no == 4)
	{
		if ((GPIO_PORT_LED4->ODR & GPIO_PIN_LED4) == 0)
		{
			return 1;
		}
		return 0;
	}

	return 0;
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
