/*
*********************************************************************************************************
*
*	ģ : RA8875оƬҵĴFlashģ
*	ļ : bsp_ra8875_flash.c
*	     : V1.3
*	˵     : RA8875ҵĴFlash ֿоƬͼоƬ֧ SST25VF016BMX25L1606E 
*			   W25Q64BVSSIG ͨTFTʾӿSPIߺPWM߿7ϵĴFlash
*				ע RA8875֧ҴFlashдӶĵӿص·ʵ֡
*	޸ļ¼ :
*		汾             ˵
*		V1.0    2012-06-25 armfly  װ
*
*	Copyright (C), 2011-2012,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

/*
	STM32F4XX ʱӼ.
		HCLK = 168M
		PCLK1 = HCLK / 4 = 42M
		PCLK2 = HCLK / 2 = 84M

		SPI2SPI3  PCLK1, ʱ42M
		SPI1        PCLK2, ʱ84M

		STM32F4 ֵ֧SPIʱΪ 37.5 Mbits/S, ҪƵ
*/

#ifdef STM32_X3 	/*  STM32-X3  */
	/*
		STM32-X4 ߷䣺 FlashͺΪ W25Q64BVSSIG (80MHz)
		PB12 = CS
		PB13 = SCK
		PB14 = MISO
		PB15 = MOSI

		STM32ӲSPIӿ = SPI2
	*/
	#define SPI_FLASH			SPI2

	#define ENABLE_SPI_RCC() 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI2, ENABLE)

	#define SPI_BAUD			SPI_BaudRatePrescaler_1		/* ѡ2Ƶʱ, SCKʱ = 21M */

	/* Ƭѡõѡ  */
	#define W25_CS_LOW()		GPIOB->BSRRH = GPIO_Pin_12

	/* Ƭѡø߲ѡ */
	#define W25_CS_HIGH()		GPIOB->BSRRL = GPIO_Pin_12
#else
	/*
		STM32-V5 TFTӿеSPI߷䣺 FlashͺΪ W25Q64BVSSIG (80MHz)
		PB3/SPI3_SCK/SPI1_SCK
		PB4/SPI3_MISO/SPI1_MISO
		PB5/SPI3_MOSI/SPI1_MOSI
		PI10/TP_NCS

		STM32ӲSPIӿ = SPI3  SPI1

		SPI1ʱԴ84M, SPI3ʱԴ42MΪ˻øٶȣѡSPI1
	*/
	//#define SPI_FLASH			SPI3
	#define SPI_FLASH			SPI1

	//#define ENABLE_SPI_RCC() 	RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI3, ENABLE)
	#define ENABLE_SPI_RCC() 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE)

	/*
		SPIʱ2Ƶֲ֧Ƶ
		SPI12ƵʱSCKʱ = 42M4ƵʱSCKʱ = 21M
		SPI3, 2ƵʱSCKʱ = 21M
	*/
	#define SPI_BAUD			SPI_BaudRatePrescaler_8

	/* ƬѡGPIO˿  */
	#define W25_CS_GPIO			GPIOI
	#define W25_CS_PIN			GPIO_Pin_10

	#define W25_PWM_GPIO		GPIOF
	#define W25_PWM_PIN			GPIO_Pin_6
#endif

/* Ƭѡõѡ  */
#define W25_CS_LOW()       W25_CS_GPIO->BSRRH = W25_CS_PIN
/* Ƭѡø߲ѡ */
#define W25_CS_HIGH()      W25_CS_GPIO->BSRRL = W25_CS_PIN


/*
	PWMõѡ
	PWM = 1  ģʽ֧STM32дRA8875ҵĴFlash
	PWM = 0 ģʽRA8875 DMAȡҵĴFlash
*/
#define W25_PWM_LOW()       W25_PWM_GPIO->BSRRH = W25_PWM_PIN
#define W25_PWM_HIGH()      W25_PWM_GPIO->BSRRL = W25_PWM_PIN


#define CMD_AAI       0xAD  	/* AAI ָ(FOR SST25VF016B) */
#define CMD_DISWR	  0x04		/* ֹд, ˳AAI״̬ */
#define CMD_EWRSR	  0x50		/* д״̬Ĵ */
#define CMD_WRSR      0x01  	/* д״̬Ĵ */
#define CMD_WREN      0x06		/* дʹ */
#define CMD_READ      0x03  	/*  */
#define CMD_RDSR      0x05		/* ״̬Ĵ */
#define CMD_RDID      0x9F		/* ID */
#define CMD_SE        0x20		/*  */
#define CMD_BE        0xC7		/*  */
#define DUMMY_BYTE    0xA5		/* Ϊֵڶ */

#define WIP_FLAG      0x01		/* ״̬Ĵеڱ̱־WIP) */


W25_T g_tW25;

void w25_ReadInfo(void);
static uint8_t w25_SendByte(uint8_t _ucValue);
static void w25_WriteEnable(void);
static void w25_WriteStatus(uint8_t _ucValue);
static void w25_WaitForWriteEnd(void);
static void bsp_CfgSPIForW25(void);

/*
*********************************************************************************************************
*	  : bsp_InitRA8875Flash
*	˵: ʼFlashӲӿڣSTM32SPIʱӡGPIO)
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitRA8875Flash(void)
{

#ifdef STM32_X3		/*  STM32-X3  */
	/*
		STM32-X3 ߷䣺 FlashͺΪ W25Q64BVSSIG (80MHz)
		PB12 = CS
		PB13 = SCK
		PB14 = MISO
		PB15 = MOSI

		STM32ӲSPIӿ = SPI2
	*/
	{
		GPIO_InitTypeDef GPIO_InitStructure;

		/* ʹGPIO ʱ */
		RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);

		/*  SCK, MISO  MOSI Ϊù */
		GPIO_PinAFConfig(GPIOB, GPIO_PinSource13, GPIO_AF_SPI2);
		GPIO_PinAFConfig(GPIOB, GPIO_PinSource14, GPIO_AF_SPI2);
		GPIO_PinAFConfig(GPIOB, GPIO_PinSource15, GPIO_AF_SPI2);

		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
		GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_DOWN;

		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14;
		GPIO_Init(GPIOB, &GPIO_InitStructure);

		/* ƬѡΪģʽ */
		W25_CS_HIGH();		/* Ƭѡøߣѡ */
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
		GPIO_Init(GPIOB, &GPIO_InitStructure);
	}
#else
	/*
		STM32-V5 ߷䣺  FlashͺΪ W25Q64BVSSIG (80MHz)
		PB3/SPI3_SCK
		PB4/SPI3_MISO
		PB5/SPI3_MOSI
		PF8/W25_CS

		STM32ӲSPIӿ = SPI3
	*/
	{
		GPIO_InitTypeDef GPIO_InitStructure;

		/* ʹGPIO ʱ */
		RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB | RCC_AHB1Periph_GPIOI| RCC_AHB1Periph_GPIOF, ENABLE);

		/*  SCK, MISO  MOSI Ϊù */
		//GPIO_PinAFConfig(GPIOB, GPIO_PinSource3, GPIO_AF_SPI3);
		//GPIO_PinAFConfig(GPIOB, GPIO_PinSource4, GPIO_AF_SPI3);
		//GPIO_PinAFConfig(GPIOB, GPIO_PinSource5, GPIO_AF_SPI3);
		/*  SCK, MISO  MOSI Ϊù */
		GPIO_PinAFConfig(GPIOB, GPIO_PinSource3, GPIO_AF_SPI1);
		GPIO_PinAFConfig(GPIOB, GPIO_PinSource4, GPIO_AF_SPI1);
		GPIO_PinAFConfig(GPIOB, GPIO_PinSource5, GPIO_AF_SPI1);

		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
		GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_DOWN;

		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3 | GPIO_Pin_4 | GPIO_Pin_5;
		GPIO_Init(GPIOB, &GPIO_InitStructure);

		/* ƬѡΪģʽ */
		W25_CS_HIGH();		/* Ƭѡøߣѡ */
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		GPIO_InitStructure.GPIO_Pin = W25_CS_PIN;
		GPIO_Init(W25_CS_GPIO, &GPIO_InitStructure);

		/* TFTӿеPWMΪΪģʽPWM = 1ʱ дRA8875ҵĴFlash */
		/* PF6/LCD_PWM  ڵRA8875ı */
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		GPIO_InitStructure.GPIO_Pin = W25_PWM_PIN;
		GPIO_Init(W25_PWM_GPIO, &GPIO_InitStructure);
	}
#endif

	/* SPIӲڷʴFlash */
	bsp_CfgSPIForW25();
}

/*
*********************************************************************************************************
*	  : w25_CtrlByMCU
*	˵: FlashȨMCU STM32
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void w25_CtrlByMCU(void)
{
	/*
		PWMõѡ
		PWM = 1  ģʽ֧STM32дRA8875ҵĴFlash
		PWM = 0 ģʽRA8875 DMAȡҵĴFlash
	*/
	W25_PWM_HIGH();
}

/*
*********************************************************************************************************
*	  : w25_CtrlByRA8875
*	˵: FlashȨRA8875
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void w25_CtrlByRA8875(void)
{
	/*
		PWMõѡ
		PWM = 1  ģʽ֧STM32дRA8875ҵĴFlash
		PWM = 0 ģʽRA8875 DMAȡҵĴFlash
	*/
	W25_PWM_LOW();
}

/*
*********************************************************************************************************
*	  : w25_SelectChip
*	˵: ѡ񼴽оƬ
*	    : _idex = FONT_CHIP ʾֿоƬ;  idex = BMP_CHIP ʾͼоƬ
*	  ֵ: 
*********************************************************************************************************
*/
void w25_SelectChip(uint8_t _idex)
{
	/*
		PWM = 1, KOUT3 = 0 дֿоƬ
		PWM = 1, KOUT3 = 1 дͼоƬ
	*/

	if (_idex == FONT_CHIP)
	{
		RA8875_CtrlGPO(3, 0);	/* RA8875  KOUT3 = 0 */
	}
	else	/* BMPͼƬоƬ */
	{
		RA8875_CtrlGPO(3, 1);	/* RA8875  KOUT3 = 1 */
	}

	w25_ReadInfo();				/* ԶʶоƬͺ */

	W25_CS_LOW();				/* ʽʹܴFlashƬѡ */
	w25_SendByte(CMD_DISWR);		/* ͽֹд,ʹд */
	W25_CS_HIGH();				/* ʽܴFlashƬѡ */

	w25_WaitForWriteEnd();		/* ȴFlashڲ */

	w25_WriteStatus(0);			/* BLOCKд */
}

/*
*********************************************************************************************************
*	  : bsp_CfgSPIForW25
*	˵: STM32ڲSPIӲĹģʽٶȵȲڷSPIӿڵĴFlash
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void bsp_CfgSPIForW25(void)
{
	SPI_InitTypeDef  SPI_InitStructure;

	/* SPIʱ */
	ENABLE_SPI_RCC();

	/* SPIӲ */
	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;	/* ݷ2ȫ˫ */
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;		/* STM32SPIģʽ ģʽ */
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;	/* λ  8λ */
	/* SPI_CPOLSPI_CPHAʹþʱӺݲλϵ
	   : ߿Ǹߵƽ,2أز)
	*/
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;			/* ʱز */
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;		/* ʱӵĵ2ز */
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;			/* ƬѡƷʽ */

	/* òԤƵϵ */
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BAUD;

	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;	/* λ򣺸λȴ */
	SPI_InitStructure.SPI_CRCPolynomial = 7;			/* CRCʽĴλΪ7̲ */
	SPI_Init(SPI_FLASH, &SPI_InitStructure);

	SPI_Cmd(SPI_FLASH, DISABLE);			/* ȽֹSPI  */

	SPI_Cmd(SPI_FLASH, ENABLE);				/* ʹSPI  */
}

/*
*********************************************************************************************************
*	  : w25_EraseSector
*	˵: ָ
*	    :  _uiSectorAddr : ַ
*	  ֵ: 
*********************************************************************************************************
*/
void w25_EraseSector(uint32_t _uiSectorAddr)
{
	w25_WriteEnable();								/* дʹ */

	/*  */
	W25_CS_LOW();									/* ʹƬѡ */
	w25_SendByte(CMD_SE);								/* Ͳ */
	w25_SendByte((_uiSectorAddr & 0xFF0000) >> 16);	/* ַĸ8bit */
	w25_SendByte((_uiSectorAddr & 0xFF00) >> 8);		/* ַм8bit */
	w25_SendByte(_uiSectorAddr & 0xFF);				/* ַ8bit */
	W25_CS_HIGH();									/* Ƭѡ */

	w25_WaitForWriteEnd();							/* ȴFlashڲд */
}

/*
*********************************************************************************************************
*	  : w25_EraseChip
*	˵: оƬ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void w25_EraseChip(void)
{
	w25_WriteEnable();								/* дʹ */

	/*  */
	W25_CS_LOW();									/* ʹƬѡ */
	w25_SendByte(CMD_BE);							/* Ƭ */
	W25_CS_HIGH();									/* Ƭѡ */

	w25_WaitForWriteEnd();							/* ȴFlashڲд */
}

/*
*********************************************************************************************************
*	  : w25_WritePage
*	˵: һpageдֽڡֽڸܳҳС4K)
*	    :  	_pBuf : Դ
*				_uiWriteAddr Ŀ׵ַ
*				_usSize ݸܳҳС
*	  ֵ: 
*********************************************************************************************************
*/
void w25_WritePage(uint8_t * _pBuf, uint32_t _uiWriteAddr, uint16_t _usSize)
{
	uint32_t i, j;

	if (g_tW25.ChipID == SST25VF016B_ID)
	{
		/* AAIָҪݸż */
		if ((_usSize < 2) && (_usSize % 2))
		{
			return ;
		}

		w25_WriteEnable();								/* дʹ */

		W25_CS_LOW();									/* ʹƬѡ */
		w25_SendByte(CMD_AAI);							/* AAI(ַԶӱ) */
		w25_SendByte((_uiWriteAddr & 0xFF0000) >> 16);	/* ַĸ8bit */
		w25_SendByte((_uiWriteAddr & 0xFF00) >> 8);		/* ַм8bit */
		w25_SendByte(_uiWriteAddr & 0xFF);				/* ַ8bit */
		w25_SendByte(*_pBuf++);							/* ͵1 */
		w25_SendByte(*_pBuf++);							/* ͵2 */
		W25_CS_HIGH();									/* Ƭѡ */

		w25_WaitForWriteEnd();							/* ȴFlashڲд */

		_usSize -= 2;									/* ʣֽ */

		for (i = 0; i < _usSize / 2; i++)
		{
			W25_CS_LOW();								/* ʹƬѡ */
			w25_SendByte(CMD_AAI);						/* AAI(ַԶӱ) */
			w25_SendByte(*_pBuf++);						/*  */
			w25_SendByte(*_pBuf++);						/*  */
			W25_CS_HIGH();								/* Ƭѡ */
			w25_WaitForWriteEnd();						/* ȴFlashڲд */
		}

		/* д״̬ */
		W25_CS_LOW();
		w25_SendByte(CMD_DISWR);
		W25_CS_HIGH();

		w25_WaitForWriteEnd();							/* ȴFlashڲд */
	}
	else	/* for MX25L1606E  W25Q64BV */
	{
		for (j = 0; j < _usSize / 256; j++)
		{
			w25_WriteEnable();								/* дʹ */

			W25_CS_LOW();									/* ʹƬѡ */
			w25_SendByte(0x02);								/* AAI(ַԶӱ) */
			w25_SendByte((_uiWriteAddr & 0xFF0000) >> 16);	/* ַĸ8bit */
			w25_SendByte((_uiWriteAddr & 0xFF00) >> 8);		/* ַм8bit */
			w25_SendByte(_uiWriteAddr & 0xFF);				/* ַ8bit */

			for (i = 0; i < 256; i++)
			{
				w25_SendByte(*_pBuf++);					/*  */
			}

			W25_CS_HIGH();								/* ֹƬѡ */

			w25_WaitForWriteEnd();						/* ȴFlashڲд */

			_uiWriteAddr += 256;
		}

		/* д״̬ */
		W25_CS_LOW();
		w25_SendByte(CMD_DISWR);
		W25_CS_HIGH();

		w25_WaitForWriteEnd();							/* ȴFlashڲд */
	}
}

/*
*********************************************************************************************************
*	  : w25_ReadBuffer
*	˵: ȡֽڡֽڸܳоƬ
*	    :  	_pBuf : Դ
*				_uiReadAddr ׵ַ
*				_usSize ݸ, ԴPAGE_SIZE,ǲܳоƬ
*	  ֵ: 
*********************************************************************************************************
*/
void w25_ReadBuffer(uint8_t * _pBuf, uint32_t _uiReadAddr, uint32_t _uiSize)
{
	/* ȡݳΪ0߳Flashַռ䣬ֱӷ */
	if ((_uiSize == 0) ||(_uiReadAddr + _uiSize) > g_tW25.TotalSize)
	{
		return;
	}

	/*  */
	W25_CS_LOW();									/* ʹƬѡ */
	w25_SendByte(CMD_READ);							/* Ͷ */
	w25_SendByte((_uiReadAddr & 0xFF0000) >> 16);	/* ַĸ8bit */
	w25_SendByte((_uiReadAddr & 0xFF00) >> 8);		/* ַм8bit */
	w25_SendByte(_uiReadAddr & 0xFF);				/* ַ8bit */
	while (_uiSize--)
	{
		*_pBuf++ = w25_SendByte(DUMMY_BYTE);			/* һֽڲ洢pBufָԼ1 */
	}
	W25_CS_HIGH();									/* Ƭѡ */
}

/*
*********************************************************************************************************
*	  : w25_ReadID
*	˵: ȡID
*	    :  
*	  ֵ: 32bitID (8bit0ЧIDλΪ24bit
*********************************************************************************************************
*/
uint32_t w25_ReadID(void)
{
	uint32_t uiID;
	uint8_t id1, id2, id3;

	W25_CS_LOW();									/* ʹƬѡ */
	w25_SendByte(CMD_RDID);								/* ͶID */
	id1 = w25_SendByte(DUMMY_BYTE);					/* IDĵ1ֽ */
	id2 = w25_SendByte(DUMMY_BYTE);					/* IDĵ2ֽ */
	id3 = w25_SendByte(DUMMY_BYTE);					/* IDĵ3ֽ */
	W25_CS_HIGH();									/* Ƭѡ */

	uiID = ((uint32_t)id1 << 16) | ((uint32_t)id2 << 8) | id3;

	return uiID;
}

/*
*********************************************************************************************************
*	  : w25_ReadInfo
*	˵: ȡID,
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void w25_ReadInfo(void)
{
	/* ԶʶFlashͺ */
	{
		g_tW25.ChipID = w25_ReadID();	/* оƬID */

		switch (g_tW25.ChipID)
		{
			case SST25VF016B:
				g_tW25.TotalSize = 2 * 1024 * 1024;	/*  = 2M */
				g_tW25.PageSize = 4 * 1024;			/* ҳС = 4K */
				break;

			case MX25L1606E:
				g_tW25.TotalSize = 2 * 1024 * 1024;	/*  = 2M */
				g_tW25.PageSize = 4 * 1024;			/* ҳС = 4K */
				break;

			case W25Q64BV:
				g_tW25.TotalSize = 8 * 1024 * 1024;	/*  = 8M */
				g_tW25.PageSize = 4 * 1024;			/* ҳС = 4K */
				break;

			default:		/* ֿͨⲻ֧IDȡ */
				g_tW25.TotalSize = 2 * 1024 * 1024;
				g_tW25.PageSize = 4 * 1024;
				break;
		}
	}
}

/*
*********************************************************************************************************
*	  : w25_SendByte
*	˵: һֽڣͬʱMISO߲ص
*	    :  _ucByte : ͵ֵֽ
*	  ֵ: MISO߲ص
*********************************************************************************************************
*/
static uint8_t w25_SendByte(uint8_t _ucValue)
{
	/* ȴϸδ */
	while (SPI_I2S_GetFlagStatus(SPI_FLASH, SPI_I2S_FLAG_TXE) == RESET);

	/* ͨSPIӲ1ֽ */
	SPI_I2S_SendData(SPI_FLASH, _ucValue);

	/* ȴһֽ */
	while (SPI_I2S_GetFlagStatus(SPI_FLASH, SPI_I2S_FLAG_RXNE) == RESET);

	/* شSPI߶ */
	return SPI_I2S_ReceiveData(SPI_FLASH);
}

/*
*********************************************************************************************************
*	  : w25_WriteEnable
*	˵: дʹ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void w25_WriteEnable(void)
{
	W25_CS_LOW();									/* ʹƬѡ */
	w25_SendByte(CMD_WREN);								/*  */
	W25_CS_HIGH();									/* Ƭѡ */
}

/*
*********************************************************************************************************
*	  : w25_WriteStatus
*	˵: д״̬Ĵ
*	    :  _ucValue : ״̬Ĵֵ
*	  ֵ: 
*********************************************************************************************************
*/
static void w25_WriteStatus(uint8_t _ucValue)
{

	if (g_tW25.ChipID == SST25VF016B_ID)
	{
		/* 1ʹд״̬Ĵ */
		W25_CS_LOW();									/* ʹƬѡ */
		w25_SendByte(CMD_EWRSR);							/*  д״̬Ĵ */
		W25_CS_HIGH();									/* Ƭѡ */

		/* 2д״̬Ĵ */
		W25_CS_LOW();									/* ʹƬѡ */
		w25_SendByte(CMD_WRSR);							/*  д״̬Ĵ */
		w25_SendByte(_ucValue);							/* ݣ״̬Ĵֵ */
		W25_CS_HIGH();									/* Ƭѡ */
	}
	else
	{
		W25_CS_LOW();									/* ʹƬѡ */
		w25_SendByte(CMD_WRSR);							/*  д״̬Ĵ */
		w25_SendByte(_ucValue);							/* ݣ״̬Ĵֵ */
		W25_CS_HIGH();									/* Ƭѡ */
	}
}

/*
*********************************************************************************************************
*	  : w25_WaitForWriteEnd
*	˵: ѭѯķʽȴڲд
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void w25_WaitForWriteEnd(void)
{
	W25_CS_LOW();									/* ʹƬѡ */
	w25_SendByte(CMD_RDSR);							/*  ״̬Ĵ */
	while((w25_SendByte(DUMMY_BYTE) & WIP_FLAG) == SET);	/* ж״̬Ĵæ־λ */
	W25_CS_HIGH();									/* Ƭѡ */
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
